package jdk.internal.org.objectweb.asm.util;

import jdk.internal.org.objectweb.asm.AnnotationVisitor;

public final class TraceAnnotationVisitor extends AnnotationVisitor
{
    private final Printer p;
    
    public TraceAnnotationVisitor(Printer printer) {
        this(null, printer);
    }
    
    public TraceAnnotationVisitor(AnnotationVisitor annotationVisitor, Printer p2) {
        super(327680, annotationVisitor);
        this.p = p2;
    }
    
    @Override
    public void visit(String name, Object value) {
        this.p.visit(name, value);
        super.visit(name, value);
    }
    
    @Override
    public void visitEnum(String name, String descriptor, String value) {
        this.p.visitEnum(name, descriptor, value);
        super.visitEnum(name, descriptor, value);
    }
    
    @Override
    public AnnotationVisitor visitAnnotation(String name, String descriptor) {
        return new TraceAnnotationVisitor((this.av == null) ? null : this.av.visitAnnotation(name, descriptor), this.p.visitAnnotation(name, descriptor));
    }
    
    @Override
    public AnnotationVisitor visitArray(String name) {
        return new TraceAnnotationVisitor((this.av == null) ? null : this.av.visitArray(name), this.p.visitArray(name));
    }
    
    @Override
    public void visitEnd() {
        this.p.visitAnnotationEnd();
        super.visitEnd();
    }
}
